MINIMUM_SPECIAL_NAME_PARTS = 2


POKEMON_TYPE_COLORS = {
    "POKEMON_TYPE_BUG": "green_yellow",
    "POKEMON_TYPE_DARK": "bright_black",
    "POKEMON_TYPE_DRAGON": "dodger_blue2",
    "POKEMON_TYPE_ELECTRIC": "yellow1",
    "POKEMON_TYPE_FAIRY": "orchid1",
    "POKEMON_TYPE_FIGHTING": "red3",
    "POKEMON_TYPE_FIRE": "orange1",
    "POKEMON_TYPE_FLYING": "light_sky_blue1",
    "POKEMON_TYPE_GHOST": "slate_blue3",
    "POKEMON_TYPE_GRASS": "green3",
    "POKEMON_TYPE_GROUND": "orange4",
    "POKEMON_TYPE_ICE": "pale_turquoise1",
    "POKEMON_TYPE_NORMAL": "grey53",
    "POKEMON_TYPE_POISON": "dark_magenta",
    "POKEMON_TYPE_PSYCHIC": "hot_pink",
    "POKEMON_TYPE_ROCK": "gold3",
    "POKEMON_TYPE_STEEL": "steel_blue",
    "POKEMON_TYPE_WATER": "cornflower_blue",
}

def format_pokemon_name(name: str, pokemon_type: str | None = None):
    parts = [part.capitalize() for part in name.split("_")]
    if parts[-1] == "Mega" or parts[-1] == "Primal":
        parts = [parts[-1]] + parts[:-1]
    if len(parts) > MINIMUM_SPECIAL_NAME_PARTS and parts[-2] == "Mega":
        parts = [parts[-2]] + parts[:-2] + [parts[-1]]
    if len(parts) > MINIMUM_SPECIAL_NAME_PARTS and parts[-2] == "Shadow":
        parts = [parts[-2]] + parts[:-2]
    formatted_name = " ".join(parts)
    if pokemon_type:
        return f"[{POKEMON_TYPE_COLORS[pokemon_type]}]{formatted_name}[/]"
    return formatted_name


def format_move_name(name):
    parts = [part.capitalize() for part in name.split("_")]
    if parts[-1] == "Fast":
        parts = parts[:-1]
    return " ".join(parts)
